//------------------------------------------------------------------------------
//** Data inizio 08/07/2000
//------------------------------------------------------------------------------

unit Poker;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ClassCards, StdCtrls, Buttons, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    BtnComand: TButton;
    BitBtn1: TBitBtn;
    SB1: TSpeedButton;
    SB2: TSpeedButton;
    SB3: TSpeedButton;
    SB4: TSpeedButton;
    SB5: TSpeedButton;
    LabelGioc: TLabel;
    LabelComp: TLabel;
    LabelPiatto: TLabel;
    LabelSoldiGioc: TLabel;
    LabelSoldiComp: TLabel;
    BtnPasso: TButton;
    BtnRilancio: TButton;
    PmenuRilancio: TPopupMenu;
    N1001: TMenuItem;
    N2001: TMenuItem;
    N3001: TMenuItem;
    N4001: TMenuItem;
    N5001: TMenuItem;
    N6001: TMenuItem;
    N8001: TMenuItem;
    N10001: TMenuItem;
    N20001: TMenuItem;
    N01: TMenuItem;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    SText: TStaticText;
    procedure BtnComandClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure AggiornaPiatto(puntata: integer; giocatore: integer);
    procedure MenuRilancioClick(Sender: TObject);
  private
    function ControllaSB: boolean; //** Controlla gli speedbuttons
    procedure AzzeraSB;
    procedure EseguiVincita(gioc: integer);
    procedure AggiornaLabels;
    function MostraCarte: integer;
    procedure SetFase(fs: integer);
    procedure ShowPokerMsg(S : string);
  end;


var
  Form1: TForm1;
  Cards: CCards;
  carteGioc: array[1..5] of TCard;


const
  _player = 85;    // Y posizione carte
  _computer = 285; // " "




//------------------------------------------------------------------------------

implementation

{$R *.DFM}

uses
  PokerEngine, Classbrain;

//------------------------------------------------------------------------------

procedure TForm1.AzzeraSB;
begin
  SB1.Down := false;
  SB2.Down := false;
  SB3.Down := false;
  SB4.Down := false;
  SB5.Down := false;
end;

//------------------------------------------------------------------------------

procedure TForm1.BtnComandClick(Sender: TObject);
var
  i: integer;
  pos: array[1..5] of Tpos;
  qnt: integer;

begin

  Case fase of

  _INIZIO:  //*********** Inizio mano **************//
  begin

    Cards.MischiaMazzo;

    //** Piatto fisso iniziale **//
    AggiornaPiatto(100, _Player);
    AggiornaPiatto(100, _Computer);

    //** Carte al giocatore **//
    for i := 1 to 5 do
      carteGioc[i] := Cards.UnaCarta(i, _player);

    //** Carte al computer **//
    for i := 1 to 5 do
      Compt.carte[i] := Cards.UnaCarta(i, _computer);

    //** Apertura **//
    SetFase(_apertura);

    LabelGioc.Caption := '';
    LabelComp.Caption := '';

  end;

  _APERTURA:  //********** APERTURA **************//
  begin

    PmenuRilancio.Popup(Mouse.CursorPos.x, Mouse.CursorPos.y);

  end;

  _CAMBIO:    //********** CAMBIO CARTE ************//
  begin

    if ControllaSB then Exit;
    if SB1.Down then
      carteGioc[1] := Cards.UnaCarta(1, _player);
    if SB2.Down then
      carteGioc[2] := Cards.UnaCarta(2, _player);
    if SB3.Down then
      carteGioc[3] := Cards.UnaCarta(3, _player);
    if SB4.Down then
      carteGioc[4] := Cards.UnaCarta(4, _player);
    if SB5.Down then
      carteGioc[5] := Cards.UnaCarta(5, _player);
    AzzeraSB;

    //** Cambio carte computer **//
    qnt := Compt.CambioCarte(pos);
    if qnt > 0 then
      labelComp.Caption := Format('Cambio %d carte', [qnt])
    else
      labelComp.Caption := 'Servito';
    for i := 1 to qnt do
      Compt.carte[pos[i]] := Cards.UnaCarta(pos[i], _computer);

    ultimaPuntata := 0;
    SetFase(_rilancio);

  end;

  _RILANCIO:  //*********** RILANCIO *************//
  begin

    PmenuRilancio.Popup(Mouse.CursorPos.x, Mouse.CursorPos.y);

  end;


  end; //** case
end;


//** Esegue i rilanci
//------------------------------------------------------------------------------

procedure TForm1.MenuRilancioClick(Sender: TObject);
var
  rilComp, vincitore: integer;
begin

  case mano of
  _PLAYER:
    begin
      case fase of
      _APERTURA:
        begin
          ultimaPuntata := (Sender as TMenuItem).Tag;
          if ultimaPuntata = 0 then
          begin
            EseguiVincita(_computer);
            LabelGioc.Caption := 'Hai passato';
            LabelComp.Caption := 'Ho vinto';
            SetFase(_inizio);
            Exit
          end;
          AggiornaPiatto(ultimaPuntata, _player);
          rilComp := Compt.Apertura;
          if rilComp = 0 then                //***** Il computer passa
          begin
            LabelGioc.Caption := 'Hai vinto';
            LabelComp.Caption := 'Passo';
            EseguiVincita(_player);
            SetFase(_inizio);
          end
          else
          begin
            if rilComp = ultimaPuntata then  //******* Il computer vede
            begin
              AggiornaPiatto(rilComp, _computer);
              LabelComp.Caption := Format('Vedo le tue %d',[ultimaPuntata])
            end
            else
            begin
              if rilComp > ultimaPuntata then   //****** Il computer rilancia
              begin
                AggiornaPiatto(rilComp, _computer);
                LabelComp.Caption :=
                  Format('Vedo le tue %d e rilancio di %d',
                        [ultimaPuntata, rilComp - ultimaPuntata]);
                Exit  //** Per non settare fase cambio
              end;
            end;
          end;
          SetFase(_cambio);
        end;

      _RILANCIO:
        begin
          ultimaPuntata := (Sender as TMenuItem).Tag;
          if (ultimaPuntata = 0) then
          begin
            EseguiVincita(_computer);
            LabelGioc.Caption := 'Hai passato';
            LabelComp.Caption := 'Ho vinto';
            SetFase(_inizio);
            Exit
          end;
          AggiornaPiatto(ultimaPuntata, _Player);
          rilComp := Compt.Rilancio;  //-- Richiesta decisione computer
          if rilComp = 0 then         //-- Il computer passa
          begin
            EseguiVincita(_player);
            LabelGioc.Caption := 'Hai vinto';
            LabelComp.Caption := 'Passo';
            SetFase(_inizio);
          end
          else
          begin
            if rilComp = ultimaPuntata then  //-- Il computer vede
            begin
              AggiornaPiatto(rilComp, _computer);
              vincitore := MostraCarte;
              case vincitore of
              _player:   EseguiVincita(_player);
              _computer: EseguiVincita(_computer);
              end;
              SetFase(_inizio);
            end
            else
            begin
              if rilComp > ultimaPuntata then  //-- Il computer rilancia
              begin
                AggiornaPiatto(rilComp, _computer);
                LabelComp.Caption := 'Vedo le tue ' +
                                   IntToStr(ultimaPuntata) +
                                   ' e rilancio di ' +
                                   IntToStr(rilComp - ultimaPuntata);
              end;
            end;
          end;
        end;
      end;
    end;

  _COMPUTER: //** Mano
    begin



    end;
  end;
end;

//------------------------------------------------------------------------------

function TForm1.ControllaSB: Boolean;
begin
  result := false;
  if (SB1.Down = true) and (SB2.Down = true) and (SB3.Down = true) and
     (SB4.Down = true) and (SB5.Down = true) then
  begin
    ShowMessage('Non puoi cambiare 5 carte: max 4!');
    result := true
  end;
end;

//------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
  piatto := 0;
  soldiGioc := 5000;
  LabelSoldiGioc.Caption := '5000';
  Compt.soldi := 10000;
  LabelSoldiComp.Caption := '10000';
  ultimaPuntata := 0;
  fase := _inizio;
  mano := _player;
  SText.Caption := 'Fai clic sul tasto inizio per dare carte';
end;

//------------------------------------------------------------------------------

procedure TForm1.AggiornaPiatto(puntata: integer; giocatore: integer);
begin
  if giocatore = _Player then
  begin
    Inc(piatto, puntata);
    Dec(soldiGioc, puntata);
    LabelPiatto.Caption := IntToStr(piatto);
    LabelSoldiGioc.Caption := IntToStr(soldiGioc)
  end
  else if giocatore = _Computer then
  begin
    Inc(piatto, puntata);
    Dec(Compt.soldi, puntata);
    LabelPiatto.Caption := IntToStr(piatto);
    LabelSoldiComp.Caption := IntToStr(Compt.soldi)
  end;
end;

//------------------------------------------------------------------------------

procedure TForm1.EseguiVincita(gioc: integer);
begin
  case gioc of
  _player:
    begin
      ShowPokerMsg(Format('Hai vinto il piatto di  %d',[piatto]));
      Inc(soldiGioc, piatto);
      piatto := 0;
      AggiornaLabels;
    end;
  _computer:
    begin
      ShowPokerMsg(Format('Il computer vince il piatto di  %d',[piatto]));
      Inc(Compt.soldi, piatto);
      piatto := 0;
      AggiornaLabels;
    end;
  end;
  //-- Cambia mano
  if mano = _player then mano := _computer else mano := _player;
end;

//------------------------------------------------------------------------------

procedure TForm1.AggiornaLabels;
begin
  LabelSoldiGioc.Caption := IntToStr(soldiGioc);
  LabelSoldiComp.Caption := IntToStr(Compt.soldi);
  LabelPiatto.Caption := IntToStr(piatto);
end;

//------------------------------------------------------------------------------

function TForm1.MostraCarte: integer;
var
  i : integer;
  pc, pp: cardinal;
begin
  //** Mostra le carte del computer **//
  for i := 1 to 5 do
    Cards.MostraUnaCarta(i{pos}, Compt.carte[i], _computer);

  LabelComp.Caption := CalcolaPunteggio(Compt.Carte, pc);
  LabelGioc.Caption := CalcolaPunteggio(CarteGioc, pp);

  if pc < pp then    //** player vince
    result := _player
  else               //** Computer vince
    result := _computer;

end;

//------------------------------------------------------------------------------

procedure TForm1.SetFase(fs: integer);
begin
  fase := fs;
  case fase of
  _INIZIO   : BtnComand.Caption := 'Inizio';
  _APERTURA : BtnComand.Caption := 'Apertura';
  _CAMBIO   : BtnComand.Caption := 'Cambio';
  _RILANCIO : BtnComand.Caption := 'Rilancio';
  end;
end;

//------------------------------------------------------------------------------





procedure TForm1.ShowPokerMsg(S: string);
begin
//
end;

end.
