
unit PokerEngine;

interface

uses
  Poker, ClassCards;


//***************** Tipo Carta

type
  TCarta = record
    num: TCardNum;
    sem: TCardSem;
  end;


//****************** Procedure e funzioni globali

function CalcolaPunteggio(carte: array of TCard;
                          var punteggio: cardinal): string;

procedure OrdinaCardNum(var arr: array of TCarta);

procedure Motore;




//******************* Variabili e costanti globali

var
  piatto:               integer;
  soldiGioc:            integer;
  ultimaPuntata:        integer;
  fase:                 integer;
  mano, manoG:          integer;


const
  _INIZIO   = 1;   //** Fasi della partita
  _APERTURA = 2;
  _CAMBIO   = 3;
  _RILANCIO = 4;
  _FINALE   = 5;

  _COPPIA          = 200; //** Punteggi
  _DOPPIA_COPPIA   = 400;
  _TRIS            = 600;
  _SCALA           = 800;
  _COLORE          = 1000;
  _FULL            = 1200;
  _POKER           = 1400;
  _SCALA_REALE     = 1600;


//------------------------------------------------------------------------------

implementation


procedure Motore;
begin
  case mano of
  _PLAYER:
    begin





    end;
  _COMPUTER:
    begin


    end;
  end;
end;


//******* Ordina l'array delle carte ***********//
//**********************************************//
procedure OrdinaCardNum(var arr: array of TCarta);
var
  i : integer;
  c : TCarta;
begin
  i := 0;
  while i < High(arr) do
  begin
    if arr[i].num > arr[i+1].num then
    begin
      c := arr[i];
      arr[i] := arr[i+1];
      arr[i+1] := c;
      Dec(i);
    end
    else
      Inc(i);
  end;
end;




function CalcolaPunteggio(carte: array of TCard;
                          var punteggio: cardinal): string;

type
  TC = record
    n: integer;   //** Coppie trovate
    t: TCardNum;  //** Valore carta
    s: TCardSem;  //** Seme carta
  end;


var
  nums, numsR: array[1..5] of TCarta;
  n: TCardNum;
  s: TCardSem;
  i, tmp, tmp2: integer;
  c1, c2: TC;

begin

  //** D i valori a numsR **//
  for i := 1 to 5 do
    Cards.NumSemFromCard( carte[i-1], numsR[i].num, numsR[i].sem );

  //** nums  la copia ordinata di numsR **//
  nums := numsR;
  OrdinaCardNum(nums);

  //** Inizializza variabili **//
  tmp := 1;
  c1.n := 0; c2.n := 0;
  c1.s := 1; c2.s := 1;

  (*
   *  Controllo primo gruppo
   *)
  while c1.n = 0 do
  begin
    for i := tmp to 4 do
    begin
      tmp := i+1;
      if nums[i].num = nums[i+1].num then
      begin
        Inc(c1.n);
        c1.t := nums[i].num;
        if nums[i].sem > nums[i+1].sem then
        begin
          if c1.s < nums[i].sem then c1.s := nums[i].sem;
        end else begin
          if c1.s < nums[i+1].sem then c1.s := nums[i+1].sem;
        end;
      end
      else  Break; //** For
    end;
    if tmp = 5 then Break; //** While
  end;

  (*
   * Controllo secondo gruppo
   *)
  if c1.n > 0 then
  begin
    while c2.n = 0 do
    begin
      for i := tmp to 4 do
      begin
        tmp := i+1;
        if nums[i].num = nums[i+1].num then
        begin
          Inc(c2.n);
          c2.t := nums[i].num;
          if nums[i].sem > nums[i+1].sem then
          begin
            if c2.s < nums[i].sem then c2.s := nums[i].sem;
          end else begin
            if c2.s < nums[i+1].sem then c2.s := nums[i+1].sem;
          end;
        end
        else break;
      end;
      if tmp >= 5 then Break;
    end;
  end;

  (*
   * Calcolo punteggi
   *)
  if c2.n > 0 then
  begin
    case c1.n of
    1:begin
        case c2.n of
        1:begin
            result := 'Doppia coppia di ';
            if c1.t > c2.t then
            begin
              result := result + Cards.NumCardToString(c1.t);
              punteggio := _DOPPIA_COPPIA + c1.t * 10 + c1.s;
            end else begin
              result := result + Cards.NumCardToString(c2.t);
              punteggio := _DOPPIA_COPPIA + c2.t * 10 + c2.s;
            end;
          end;
        2:begin
            result := 'Full di ' + Cards.NumCardToString(c2.t);
            punteggio := _FULL + c2.t * 10 + c2.s;
          end;
        end;
      end;
    2:begin
        result := 'Full di ' + Cards.NumCardToString(c1.t);
        punteggio := _FULL + c1.t * 10 + c2.s;
      end;
    end;
  end
  else    //** Se not(c2 > 0) controlla c1
  if c1.n > 0 then
  begin
    case c1.n of
    1:begin
        result := 'Coppia di ' + Cards.NumCardToString(c1.t);
        punteggio := _COPPIA + c1.t * 10 + c1.s;
      end;
    2:begin
        result := 'Tris di ' + Cards.NumCardToString(c1.t);
        punteggio := _TRIS + c1.t * 10 + c1.s;
      end;
    3:begin
        result := 'Poker di ' + Cards.NumCardToString(c1.t);
        punteggio := _POKER + c1.t * 10 + c1.s;
      end;
    end;
  end
  else
  begin  //** Tutti diversi controlla per scala e colore
    tmp := 0;
    for i := 1 to 4 do  //** Controlla per scala
      if nums[i].num + 1 = nums[i+1].num then Inc(tmp) else Break;
    case tmp of
    4:begin
        result := 'Scala al ' + Cards.CardToString(nums[5].num, nums[5].sem);
        punteggio := _SCALA + nums[5].num * 10 + nums[5].sem;
      end;
    else //** case tmp
      begin   //** Controlla per colore
        tmp2 := 0;
        for i := 1 to 4 do
          if nums[i].sem = nums[i+1].sem then Inc(tmp2) else Break;
        case tmp2 of
        4:begin  //** Colore trovato
            result := 'Colore a ' + Cards.NumSemToString(nums[5].sem);
            punteggio := _COLORE + nums[5].sem;
          end
        else //** case tmp2
          begin  //** Nulla carta pi alta
            n := 1; s := 1;
            for i := 1 to 5 do
            begin
              if numsR[i].num > n then
              begin
                n := numsR[i].num;
                s := numsR[i].sem;
              end;
              punteggio := n * 10 + s;
              result := Cards.CardToString(n, s);
            end;
          end;
        end; //case tmp2
      end;
    end; //case tmp
  end; //else not c1.n > 0
end;



end.

